=== modified file 'Makefile'
--- Makefile	2012-06-01 18:39:03 +0000
+++ Makefile	2012-05-24 18:10:10 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.5.5
+version=1.5.4
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== modified file 'NEWS'
--- NEWS	2012-06-01 18:39:03 +0000
+++ NEWS	2012-05-20 13:52:09 +0000
@@ -1,10 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.5.5 (2012-06-01)
-* Server
-** Server takes new --socket option
-
 Version 1.5.4 (2012-05-20)
 * Server
 ** Bug fix: Regression fix: Make non-zero approval timeout values work.

=== modified file 'TODO'
--- TODO	2012-05-26 22:21:17 +0000
+++ TODO	2012-05-12 19:29:05 +0000
@@ -48,6 +48,8 @@
    SetLogLevel D-Bus call
 ** TODO Implement --foreground						  :BUGS:
    [[info:standards:Option%20Table][Table of Long Options]]
+** TODO Implement --socket
+   [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on number of secrets given

=== modified file 'common.ent'
--- common.ent	2012-06-01 18:39:03 +0000
+++ common.ent	2012-05-20 13:52:09 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.5.5">
+<!ENTITY version "1.5.4">

=== modified file 'debian/changelog'
--- debian/changelog	2012-06-01 18:39:03 +0000
+++ debian/changelog	2012-05-20 13:52:09 +0000
@@ -1,12 +1,3 @@
-mandos (1.5.5-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/copyright (Format): Updated to
-    "http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/".
-  * debian/control (Build-Depends): Removed "man, locales-all".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Fri, 01 Jun 2012 20:30:41 +0200
-
 mandos (1.5.4-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/copyright'
--- debian/copyright	2012-06-01 21:48:12 +0000
+++ debian/copyright	2012-05-24 18:10:10 +0000
@@ -5,7 +5,7 @@
 
 Files: *
 Copyright: Copyright © 2008-2012 Teddy Hogeborn
-	   Copyright © 2008-2012 Björn Påhlsson
+Copyright: Copyright © 2008-2012 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.README.Debian	2012-01-01 04:52:07 +0000
@@ -56,7 +56,7 @@
   the interface (see mandos-client(8mandos)) and placing it in
   "/etc/mandos/network-hooks.d", from where it will be copied into the
   initial RAM disk.  Example network hook scripts can be found in
-  "/usr/share/doc/mandos-client/examples/network-hooks.d".
+  "/usr/share/doc/mandos-client/network-hooks.d".
 
 * User-Supplied Plugins
   
@@ -90,4 +90,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Fri,  1 Jun 2012 23:46:13 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Mon, 28 Nov 2011 23:07:22 +0100

=== modified file 'debian/mandos-client.docs'
--- debian/mandos-client.docs	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.docs	2011-11-27 02:32:20 +0000
@@ -1,3 +1,4 @@
 NEWS
 README
 TODO
+network-hooks.d

=== removed file 'debian/mandos-client.examples'
--- debian/mandos-client.examples	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.examples	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-network-hooks.d

=== modified file 'debian/rules'
--- debian/rules	2012-06-01 21:48:12 +0000
+++ debian/rules	2012-02-21 21:20:12 +0000
@@ -79,7 +79,6 @@
 	dh_testroot
 	dh_installchangelogs
 	dh_installdocs
-	dh_installexamples
 	dh_link
 	dh_strip
 	dh_compress
@@ -87,7 +86,7 @@
 		--exclude etc/mandos/clients.conf \
 		--exclude etc/mandos/plugins.d \
 		--exclude usr/lib/mandos/plugins.d \
-		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
+		--exclude usr/share/doc/mandos-client/network-hooks.d
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol

=== modified file 'init.d-mandos'
--- init.d-mandos	2012-06-01 21:48:12 +0000
+++ init.d-mandos	2011-10-05 16:00:56 +0000
@@ -149,9 +149,6 @@
 		;;
 	esac
 	;;
-  status)
-	status_of_proc "$DAEMON" "$NAME" -p "$PIDFILE"
-	;;
   *)
 	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
 	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2

=== modified file 'mandos'
--- mandos	2012-06-01 18:39:03 +0000
+++ mandos	2012-05-26 22:48:45 +0000
@@ -88,7 +88,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.5.5"
+version = "1.5.4"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -1899,42 +1899,12 @@
         use_ipv6:       Boolean; to use IPv6 or not
     """
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None, use_ipv6=True, socketfd=None):
-        """If socketfd is set, use that file descriptor instead of
-        creating a new one with socket.socket().
-        """
+                 interface=None, use_ipv6=True):
         self.interface = interface
         if use_ipv6:
             self.address_family = socket.AF_INET6
-        if socketfd is not None:
-            # Save the file descriptor
-            self.socketfd = socketfd
-            # Save the original socket.socket() function
-            self.socket_socket = socket.socket
-            # To implement --socket, we monkey patch socket.socket.
-            # 
-            # (When socketserver.TCPServer is a new-style class, we
-            # could make self.socket into a property instead of monkey
-            # patching socket.socket.)
-            # 
-            # Create a one-time-only replacement for socket.socket()
-            @functools.wraps(socket.socket)
-            def socket_wrapper(*args, **kwargs):
-                # Restore original function so subsequent calls are
-                # not affected.
-                socket.socket = self.socket_socket
-                del self.socket_socket
-                # This time only, return a new socket object from the
-                # saved file descriptor.
-                return socket.fromfd(self.socketfd, *args, **kwargs)
-            # Replace socket.socket() function with wrapper
-            socket.socket = socket_wrapper
-        # The socketserver.TCPServer.__init__ will call
-        # socket.socket(), which might be our replacement,
-        # socket_wrapper(), if socketfd was set.
         socketserver.TCPServer.__init__(self, server_address,
                                         RequestHandlerClass)
-    
     def server_bind(self):
         """This overrides the normal server_bind() function
         to bind to an interface if one was specified, and also NOT to
@@ -1998,7 +1968,7 @@
     """
     def __init__(self, server_address, RequestHandlerClass,
                  interface=None, use_ipv6=True, clients=None,
-                 gnutls_priority=None, use_dbus=True, socketfd=None):
+                 gnutls_priority=None, use_dbus=True):
         self.enabled = False
         self.clients = clients
         if self.clients is None:
@@ -2008,8 +1978,7 @@
         IPv6_TCPServer.__init__(self, server_address,
                                 RequestHandlerClass,
                                 interface = interface,
-                                use_ipv6 = use_ipv6,
-                                socketfd = socketfd)
+                                use_ipv6 = use_ipv6)
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
@@ -2196,9 +2165,6 @@
     parser.add_argument("--no-restore", action="store_false",
                         dest="restore", help="Do not restore stored"
                         " state")
-    parser.add_argument("--socket", type=int,
-                        help="Specify a file descriptor to a network"
-                        " socket to use instead of creating one")
     parser.add_argument("--statedir", metavar="DIR",
                         help="Directory to save/restore state in")
     
@@ -2221,7 +2187,6 @@
                         "use_ipv6": "True",
                         "debuglevel": "",
                         "restore": "True",
-                        "socket": "",
                         "statedir": "/var/lib/mandos"
                         }
     
@@ -2239,15 +2204,6 @@
     if server_settings["port"]:
         server_settings["port"] = server_config.getint("DEFAULT",
                                                        "port")
-    if server_settings["socket"]:
-        server_settings["socket"] = server_config.getint("DEFAULT",
-                                                         "socket")
-        # Later, stdin will, and stdout and stderr might, be dup'ed
-        # over with an opened os.devnull.  But we don't want this to
-        # happen with a supplied network socket.
-        if 0 <= server_settings["socket"] <= 2:
-            server_settings["socket"] = os.dup(server_settings
-                                               ["socket"])
     del server_config
     
     # Override the settings from the config file with command line
@@ -2255,7 +2211,7 @@
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
                    "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket"):
+                   "statedir"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2309,9 +2265,7 @@
                               use_ipv6=use_ipv6,
                               gnutls_priority=
                               server_settings["priority"],
-                              use_dbus=use_dbus,
-                              socketfd=(server_settings["socket"]
-                                        or None))
+                              use_dbus=use_dbus)
     if not debug:
         pidfilename = "/var/run/mandos.pid"
         try:

=== modified file 'mandos-ctl'
--- mandos-ctl	2012-06-01 18:39:03 +0000
+++ mandos-ctl	2012-05-20 13:52:09 +0000
@@ -63,7 +63,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.5.5"
+version = "1.5.4"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""

=== modified file 'mandos-keygen'
--- mandos-keygen	2012-06-01 18:39:03 +0000
+++ mandos-keygen	2012-05-20 13:52:09 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.5.5"
+VERSION="1.5.4"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2012-06-01 18:39:03 +0000
+++ mandos-monitor	2012-05-20 13:52:09 +0000
@@ -55,7 +55,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.5.5"
+version = "1.5.4"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2012-05-26 22:21:17 +0000
+++ mandos-options.xml	2012-01-01 04:02:00 +0000
@@ -97,10 +97,4 @@
     class="directory">/var/lib/mandos</filename></quote>.
   </para>
   
-  <para id="socket">
-    If this option is used, the server will not create a new network
-    socket, but will instead use the supplied file descriptor.  By
-    default, the server will create a new network socket.
-  </para>
-  
 </section>

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2012-05-26 22:21:17 +0000
+++ mandos.conf.xml	2011-12-31 23:05:34 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2012-05-26">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -174,14 +174,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>socket<literal> = </literal><replaceable
-	>NUMBER</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="socket"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'mandos.lsm'
--- mandos.lsm	2012-06-01 18:39:03 +0000
+++ mandos.lsm	2012-05-20 13:52:09 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.5.5
-Entered-date:	2012-06-01
+Version:	1.5.4
+Entered-date:	2012-05-20
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      148K mandos_1.5.5.orig.tar.gz
+	      148K mandos_1.5.4.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		148K mandos_1.5.5.orig.tar.gz
+		148K mandos_1.5.4.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2012-05-26 22:21:17 +0000
+++ mandos.xml	2012-01-15 21:01:13 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2012-05-26">
+<!ENTITY TIMESTAMP "2012-01-15">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -100,9 +100,6 @@
       <sbr/>
       <arg><option>--statedir
       <replaceable>DIRECTORY</replaceable></option></arg>
-      <sbr/>
-      <arg><option>--socket
-      <replaceable>FD</replaceable></option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -302,15 +299,6 @@
 	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
 	</listitem>
       </varlistentry>
-      
-      <varlistentry>
-	<term><option>--socket
-	<replaceable>FD</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="socket"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2012-06-07 21:00:57 +0000
+++ plugins.d/mandos-client.c	2012-05-24 18:45:45 +0000
@@ -135,8 +135,6 @@
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 const char *hookdir = HOOKDIR;
-uid_t uid = 65534;
-gid_t gid = 65534;
 
 /* Doubly linked list that need to be circularly linked when used */
 typedef struct server{
@@ -1392,49 +1390,6 @@
   }
 }
 
-/* Set effective uid to 0, return errno */
-int raise_privileges(void){
-  int old_errno = errno;
-  int ret_errno = 0;
-  errno = 0;
-  if(seteuid(0) == -1){
-    perror_plus("seteuid");
-  }
-  ret_errno = errno;
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective and real user ID to 0.  Return errno. */
-int raise_privileges_permanently(void){
-  int old_errno = errno;
-  int ret_errno = raise_privileges();
-  if(ret_errno != 0){
-    errno = old_errno;
-    return ret_errno;
-  }
-  errno = 0;
-  if(setuid(0) == -1){
-    perror_plus("seteuid");
-  }
-  ret_errno = errno;
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective user ID to unprivileged saved user ID */
-int lower_privileges(void){
-  int old_errno = errno;
-  int ret_errno = 0;
-  errno = 0;
-  if(seteuid(uid) == -1){
-    perror_plus("seteuid");
-  }
-  ret_errno = errno;
-  errno = old_errno;
-  return ret_errno;
-}
-
 bool run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
   struct dirent **direntries;
@@ -1462,7 +1417,17 @@
       if(hook_pid == 0){
 	/* Child */
 	/* Raise privileges */
-	raise_privileges_permanently();
+	errno = 0;
+	ret = seteuid(0);
+	if(ret == -1){
+	  perror_plus("seteuid");
+	}
+	/* Raise privileges even more */
+	errno = 0;
+	ret = setuid(0);
+	if(ret == -1){
+	  perror_plus("setuid");
+	}
 	/* Set group */
 	errno = 0;
 	ret = setgid(0);
@@ -1561,128 +1526,6 @@
   return true;
 }
 
-int bring_up_interface(const char * const interface, const float delay){
-  int sd = -1;
-  int old_errno = errno;
-  int ret_errno = 0;
-  int ret;
-  struct ifreq network;
-  AvahiIfIndex if_index = (AvahiIfIndex)if_nametoindex(interface);
-  if(if_index == 0){
-    fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
-    errno = old_errno;
-    return ENXIO;
-  }
-  
-  if(quit_now){
-    errno = old_errno;
-    return EINTR;
-  }
-  
-  /* Re-raise priviliges */
-  raise_privileges();
-  
-#ifdef __linux__
-  /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
-     messages about the network interface to mess up the prompt */
-  ret = klogctl(8, NULL, 5);
-  bool restore_loglevel = true;
-  if(ret == -1){
-    restore_loglevel = false;
-    perror_plus("klogctl");
-  }
-#endif	/* __linux__ */
-    
-  sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-  if(sd < 0){
-    ret_errno = errno;
-    perror_plus("socket");
-#ifdef __linux__
-    if(restore_loglevel){
-      ret = klogctl(7, NULL, 0);
-      if(ret == -1){
-	perror_plus("klogctl");
-      }
-    }
-#endif	/* __linux__ */
-    /* Lower privileges */
-    lower_privileges();
-    errno = old_errno;
-    return ret_errno;
-  }
-  strcpy(network.ifr_name, interface);
-  ret = ioctl(sd, SIOCGIFFLAGS, &network);
-  if(ret == -1){
-    ret_errno = errno;
-    perror_plus("ioctl SIOCGIFFLAGS");
-#ifdef __linux__
-    if(restore_loglevel){
-      ret = klogctl(7, NULL, 0);
-      if(ret == -1){
-	perror_plus("klogctl");
-      }
-    }
-#endif	/* __linux__ */
-    /* Lower privileges */
-    lower_privileges();
-    errno = old_errno;
-    return ret_errno;
-  }
-  if((network.ifr_flags & IFF_UP) == 0){
-    network.ifr_flags |= IFF_UP;
-    ret = ioctl(sd, SIOCSIFFLAGS, &network);
-    if(ret == -1){
-      ret_errno = errno;
-      perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
-#ifdef __linux__
-      if(restore_loglevel){
-	ret = klogctl(7, NULL, 0);
-	if(ret == -1){
-	  perror_plus("klogctl");
-	}
-      }
-#endif	/* __linux__ */
-	/* Lower privileges */
-      lower_privileges();
-      errno = old_errno;
-      return ret_errno;
-    }
-  }
-  /* Sleep checking until interface is running.
-     Check every 0.25s, up to total time of delay */
-  for(int i=0; i < delay * 4; i++){
-    ret = ioctl(sd, SIOCGIFFLAGS, &network);
-    if(ret == -1){
-      perror_plus("ioctl SIOCGIFFLAGS");
-    } else if(network.ifr_flags & IFF_RUNNING){
-      break;
-    }
-    struct timespec sleeptime = { .tv_nsec = 250000000 };
-    ret = nanosleep(&sleeptime, NULL);
-    if(ret == -1 and errno != EINTR){
-      perror_plus("nanosleep");
-    }
-  }
-  /* Close the socket */
-  ret = (int)TEMP_FAILURE_RETRY(close(sd));
-  if(ret == -1){
-    perror_plus("close");
-  }
-#ifdef __linux__
-  if(restore_loglevel){
-    /* Restores kernel loglevel to default */
-    ret = klogctl(7, NULL, 0);
-    if(ret == -1){
-      perror_plus("klogctl");
-    }
-  }
-#endif	/* __linux__ */
-  /* Lower privileges */
-  lower_privileges();
-  errno = old_errno;
-  return 0;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1694,6 +1537,8 @@
   struct ifreq network;
   int sd = -1;
   bool take_down_interface = false;
+  uid_t uid;
+  gid_t gid;
   char tempdir[] = "/tmp/mandosXXXXXX";
   bool tempdir_created = false;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
@@ -1879,7 +1724,11 @@
        <http://bugs.debian.org/633582> */
     
     /* Re-raise priviliges */
-    if(raise_privileges() == 0){
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    } else {
       struct stat st;
       
       if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
@@ -2050,11 +1899,139 @@
   }
   
   /* If the interface is down, bring it up */
-  if((interface[0] != '\0') and (strcmp(interface, "none") != 0)){
-    ret = bring_up_interface(interface, delay);
-    if(ret != 0){
-      errno = ret;
-      perror_plus("Failed to bring up interface");
+  if(strcmp(interface, "none") != 0){
+    if_index = (AvahiIfIndex) if_nametoindex(interface);
+    if(if_index == 0){
+      fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
+      exitcode = EX_UNAVAILABLE;
+      goto end;
+    }
+    
+    if(quit_now){
+      goto end;
+    }
+    
+    /* Re-raise priviliges */
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
+    
+#ifdef __linux__
+    /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
+       messages about the network interface to mess up the prompt */
+    ret = klogctl(8, NULL, 5);
+    bool restore_loglevel = true;
+    if(ret == -1){
+      restore_loglevel = false;
+      perror_plus("klogctl");
+    }
+#endif	/* __linux__ */
+    
+    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+    if(sd < 0){
+      perror_plus("socket");
+      exitcode = EX_OSERR;
+#ifdef __linux__
+      if(restore_loglevel){
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror_plus("klogctl");
+	}
+      }
+#endif	/* __linux__ */
+      /* Lower privileges */
+      errno = 0;
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
+      }
+      goto end;
+    }
+    strcpy(network.ifr_name, interface);
+    ret = ioctl(sd, SIOCGIFFLAGS, &network);
+    if(ret == -1){
+      perror_plus("ioctl SIOCGIFFLAGS");
+#ifdef __linux__
+      if(restore_loglevel){
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror_plus("klogctl");
+	}
+      }
+#endif	/* __linux__ */
+      exitcode = EX_OSERR;
+      /* Lower privileges */
+      errno = 0;
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
+      }
+      goto end;
+    }
+    if((network.ifr_flags & IFF_UP) == 0){
+      network.ifr_flags |= IFF_UP;
+      take_down_interface = true;
+      ret = ioctl(sd, SIOCSIFFLAGS, &network);
+      if(ret == -1){
+	take_down_interface = false;
+	perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
+	exitcode = EX_OSERR;
+#ifdef __linux__
+	if(restore_loglevel){
+	  ret = klogctl(7, NULL, 0);
+	  if(ret == -1){
+	    perror_plus("klogctl");
+	  }
+	}
+#endif	/* __linux__ */
+	/* Lower privileges */
+	errno = 0;
+	ret = seteuid(uid);
+	if(ret == -1){
+	  perror_plus("seteuid");
+	}
+	goto end;
+      }
+    }
+    /* Sleep checking until interface is running.
+       Check every 0.25s, up to total time of delay */
+    for(int i=0; i < delay * 4; i++){
+      ret = ioctl(sd, SIOCGIFFLAGS, &network);
+      if(ret == -1){
+	perror_plus("ioctl SIOCGIFFLAGS");
+      } else if(network.ifr_flags & IFF_RUNNING){
+	break;
+      }
+      struct timespec sleeptime = { .tv_nsec = 250000000 };
+      ret = nanosleep(&sleeptime, NULL);
+      if(ret == -1 and errno != EINTR){
+	perror_plus("nanosleep");
+      }
+    }
+    if(not take_down_interface){
+      /* We won't need the socket anymore */
+      ret = (int)TEMP_FAILURE_RETRY(close(sd));
+      if(ret == -1){
+	perror_plus("close");
+      }
+    }
+#ifdef __linux__
+    if(restore_loglevel){
+      /* Restores kernel loglevel to default */
+      ret = klogctl(7, NULL, 0);
+      if(ret == -1){
+	perror_plus("klogctl");
+      }
+    }
+#endif	/* __linux__ */
+    /* Lower privileges */
+    errno = 0;
+    /* Lower privileges */
+    ret = seteuid(uid);
+    if(ret == -1){
+      perror_plus("seteuid");
     }
   }
   
@@ -2101,7 +2078,6 @@
     /* Connect directly, do not use Zeroconf */
     /* (Mainly meant for debugging) */
     char *address = strrchr(connect_to, ':');
-    
     if(address == NULL){
       fprintf_plus(stderr, "No colon in address\n");
       exitcode = EX_USAGE;
@@ -2270,7 +2246,11 @@
   
   /* Re-raise priviliges */
   {
-    raise_privileges();
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
     
     /* Take down the network interface */
     if(take_down_interface and geteuid() == 0){

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2012-05-27 07:30:49 +0000
+++ plugins.d/mandos-client.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2012-05-27">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -661,7 +661,7 @@
     <informalexample>
       <para>
 	Normal invocation needs no options, if the network interface
-	can be automatically determined:
+	is <quote>eth0</quote>:
       </para>
       <para>
 	<userinput>&COMMANDNAME;</userinput>

